/**
 * Copyright 2006 mapeasy.sf.net.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * ֧֣ҪģͶҪ̳
 * ߿(ListenerSupport.apply(this))
 * 
 * @author Tim.Wu Michael.Young
 */
function ListenerSupport() {

	//~ Field
	/** ߼ An array [params] of listener */
	this.listeners = new Array();
	
	/** ֵ An array [params] of values.*/
	this.values = new Array();
	
	//~ Method
	/**
	 * һ
	 *
	 * @param param ߹ע
	 * @param listener 
	 */
	this.addListener = function(param, listener) {
		if(!this.listeners[param]) {
			this.listeners[param] = new Array();
		}
		// Ƴɵ
		this.removeListener(param, listener);
		// µ
		this.listeners[param].push(listener);
	}
	
	/**
	 * һߵλ
	 */
	this.addFirstListener = function(param, listener) {
		if(!this.listeners[param]){
			this.listeners[param] = new Array();
		}
		this.removeListener(param, listener);
		this.listeners[param].unshift(listener);
	}

	/**
	 * Ƴһ
	 *
	 * @param param
	 * @param listener
	 */
	this.removeListener = function(param, listener) {
		if(this.listeners[param]) {
			for(var i = 0;i < this.listeners[param].length;i++){
				if(this.listeners[param][i] == listener) {
					for(var j = i;i < this.listeners[param].length - 1;i++){
						this.listeners[param][j] = this.listeners[param][j+1];
					}
					this.listeners[param].pop();
					return;
				}
			}
		}
	}
	
	/**
	 * ֪ͨĳм߲ı
	 *
	 * @param param ߹ע
	 * @param value µֵ
	 */
	this.notifyListeners = function(param, newValue) {
		if(this.listeners[param]) {
			var count = this.listeners[param].length;
			for(var i = 0;i < count;i++){
				if(this.listeners[param][i]) {
					// ִмߵķ
					this.listeners[param][i].propertyChange(param, newValue);
				}
			}
		}
	}
	
	/**
	 * ıĳעֵ
	 *
	 * @param param ҪıĲ
	 * @parma value µֵ
	 */
	this.firePropertyChange = function(param, newValue) {
		this.values[param] = newValue;
		this.notifyListeners(param, newValue);
	}
	
	/**
	 * ĳעֵ
	 */
	this.getParamValue = function(param) {
		return this.values[param];
	}
}