/**
 * Copyright 2006 mapeasy.sf.net.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * ͼģ
 * 
 * @author Tim.Wu Michael.Young
 */
function MapModel(id) {
	
	// Inherit from BaseModel
	BaseModel.apply(this);

	//~ Field
	this.id = id;

	/** ű */
	this.zoom;
	
	/** ʾ */
	this.viewerCenterCoord;
	
	/** ʾ */
	this.viewerBound;
	
	/** Ĭʾ */
	this.defaultCoord;
	
	/** Ĭʾ */
	this.defaultZoom;

	/** Ｏ */
	this.overlays;
	
	/** ͼ¼ */
	this.events = new Array();

	/** ͼ */
	this.currentMapType = 0;

	//~ Method
	this.getZoom = function() {
		return this.zoom;
	}

	this.setZoom = function(zoom) {
		this.zoom = zoom;
		this.zoom.setMap(this);
		this.firePropertyChange("zoom");
	}

	this.setViewerCenterCoord = function(coord){
		this.viewerCenterCoord = coord;
		this.firePropertyChange("move");
	}

	this.getViewerCenterCoord = function() {
		return this.viewerCenterCoord;
	}

	this.setViewerBound = function(viewerBound) {
		this.viewerBound = viewerBound;
	}

	this.getViewerBound = function() {
		return this.viewerBound;
	}

	this.setDefault = function(defaultCoord, defaultZoom) {
		this.defaultCoord = defaultCoord;
		this.defaultZoom = defaultZoom;
	}

	this.reset = function() {
		this.setViewerCenterCoord(this.defaultCoord);
		this.setZoom(this.defaultZoom);
	}
	
	/**
	 * Ӹ
	 */
	this.addOverlay = function(overlay) {
		if (this.overlays == null) {
			this.overlays = new Array();
		}
		this.overlays.push(overlay);
		this.firePropertyChange("addoverlay", overlay);
		return overlay;
	}
	
	/**
	 * Ƴĳ
	 */
	this.removeOverlay = function(overlay) {
		if (this.overlays) {
			this.overlays = this.overlays.without(overlay);
		}
	}
	
	/**
	 * и
	 */
	this.clearOverlays = function() {
		if (this.overlays) {
			this.overlays.clear();
		}
	}

	this.getOverlays = function() {
		return this.overlays;
	}

	this.getId = function() {
		return this.id;
	}

	this.setCurrentMapType = function(arrIndex) {
		this.currentMapType = arrIndex;
		this.firePropertyChange("maptype");
	}
}

/**
 * ͼ
 *
 * @author Tim.Wu Michael.Young
 */
function MapType() {
	
	this.enablePic;

	this.disablePic;
	
	//~ Method
	{
		this.enablePic = imgBaseDir + "maptype_0b.gif";
		this.disablePic = imgBaseDir + "maptype_0a.gif";
	}

	this.getSrc = function(level, row, column) {
		return imgBaseDir + 'zoom_' + level + '/' + level + '_' + column + '_' + row + '.jpg';
	}

	this.getEnablePic = function() {
		return this.enablePic;
	}

	this.getDisablePic = function() {
		return this.disablePic;
	}
}

/** ͼģͳ */
/** ͼϵΧ */
MapModel.bound = new Bound(-180e16, 180e16, -90e16, 90e16);
/** һŵȼƬ */
MapModel.firstZoomTileNum = 1;
/** ÿ֮ı */
MapModel.scalePara = 2;
/** Ƭߴ */
MapModel.tileSize = 256;
/** ű */
MapModel.maxZoomLevel = 5;
/** ͼͼ */
MapModel.mapTypes = new Array();
MapModel.mapTypes.push(new MapType());

/**
 * ĳģ
 * 
 * @author Tim.Wu Michael.Young
 */
function Zoom(level) {
	
	//~ Field
	/** ȼ */
	this.level = level;
	
	/** Ƭ */
	this.tilesNum;
	
	/** ԵƬ */
	this.borderTilesNum;
	
	/**  */
	this.viewerBound;

	this.map;

	//~ Method
	{	
		this.tilesNum = Math.pow(Math.pow(MapModel.scalePara, (this.level - 1)), 2) * MapModel.firstZoomTileNum;
		this.borderTilesNum = Math.sqrt(this.tilesNum);
		// ϵԭΪĵĿ
		this.viewerBound = MapModel.bound.getCenterCoord().getBound(MapModel.bound.getWidth() * viewerWidth / (this.borderTilesNum * MapModel.tileSize), MapModel.bound.getHeight() * viewerHeight / (this.borderTilesNum * MapModel.tileSize));
	}

	this.getLevel = function() {
		return this.level;
	}
	
	this.setMap = function(map) {
		this.map = map;
	}

	/**
	 * ȡĳΪĵĿƬ
	 *
	 * @param coord ĵ
	 */
	this.getTiles = function(coord) {
		// ¶λ
		if (this.viewerBound.getCenterCoord() != coord) {
			this.viewerBound = this.viewerBound.clone(coord);
		}
		if (!MapModel.bound.isCover(this.viewerBound)) {
			// ڵͼ֮
			return null;
		} else {
			// еͼ
			var tiles = new Array();
			var rowFrom = Math.floor((MapModel.bound.getMaxY() - this.viewerBound.getMaxY()) / (MapModel.bound.getHeight() / this.borderTilesNum));
			rowFrom = rowFrom<0?0:rowFrom;
			var rowTo = Math.floor((this.viewerBound.getMinY() - MapModel.bound.getMinY()) / (MapModel.bound.getHeight() / this.borderTilesNum));
			rowTo = rowTo<0?this.borderTilesNum:(this.borderTilesNum - rowTo);
			var columnFrom = Math.floor((this.viewerBound.getMinX() - MapModel.bound.getMinX()) / (MapModel.bound.getWidth() / this.borderTilesNum));
			columnFrom = columnFrom<0?0:columnFrom;
			var columnTo = Math.floor((MapModel.bound.getMaxX() - this.viewerBound.getMaxX()) / (MapModel.bound.getWidth() / this.borderTilesNum));
			columnTo = columnTo<0?this.borderTilesNum:(this.borderTilesNum - columnTo);
			for (var i = rowFrom;i < rowTo;i++) {
				for (var j = columnFrom;j < columnTo;j++) {
					var tile = new Tile(i, j, this.level);
					tile.setMap(this.map);
					tiles.push(tile);
				}
			}
			return tiles;
		}
	}

	this.getBorderTilesNum = function() {
		return this.borderTilesNum;
	}
	
	this.getViewerBound = function() {
		return this.viewerBound;
	}

	this.setViewerBound = function(viewerBound) {
		this.viewerBound = viewerBound;
	}

	this.getLevel = function() {
		return this.level;
	}
}

/**
 * Ƭ
 *
 * @author Tim.Wu Michael.Young
 */
function Tile(row, column, level) {
	
	//~ Field
	this.row = row;
	
	this.column = column;
	
	this.level = level;

	this.map;

	//~ Method
	/**
	 * õƬͼƬ
	 */
	this.getSrc = function() {
		return MapModel.mapTypes[this.map.currentMapType].getSrc(this.level, this.row, this.column);
	}

	this.getRow = function() {
		return this.row;
	}

	this.getColumn = function() {
		return this.column;
	}

	this.setMap = function(map) {
		this.map = map;
	}
}

